#pragma once

#include <stdint.h>
#include "utils.hpp"

namespace Devices::I2c {

    class HwSync
    {
        public:

            static bool Configure(int32_t f);
            static bool Init();
            static bool Start(uint8_t const address, Direction const direction);
            static bool Stop();
            static bool Transmit(uint8_t byte);
            static bool Transmit(uint8_t const size, void const * const buffer);
            static bool TransmitProgmem(uint8_t const size, void const * const buffer);
            static bool ReceiveAck(uint8_t & byte);
            static bool ReceiveNack(uint8_t & byte);
            static bool ReceiveAck(uint8_t const size, void * const buffer);
            static bool ReceiveNack(uint8_t const size, void * const buffer);

    };
}