#pragma once

#include <stdint.h>
#include <ff.h>


namespace Voltmeter
{
    class Player
    {
        public:

            Player();

            bool MountFs();
            bool OpenFile(char const * const path);
            bool Play();

            bool IsPlaying();
            uint16_t GetProgress();

            int16_t GetSample();

        private:

            constexpr static uint8_t const WAV_HEADER_SIZE = 0x2c;
            constexpr static uint16_t const  PLAYBACK_BUFFER_LEN = 512;
            
            uint8_t PLAYBACK_BUFFER[PLAYBACK_BUFFER_LEN];
            volatile uint16_t PLAYBACK_INDEX;
            uint16_t offset;

            uint32_t position;
            uint32_t data_length;
            FATFS fs;
            FIL file;

            bool fileOpen;
    };
}
